#!/usr/bin/env python
# -*- coding:utf-8 -*-

import pandas as pd
import mysql.connector
import sys
 
reload(sys)
sys.setdefaultencoding('utf-8')

def get_user_info(user_ids, conn=None):
  '''
  通过user_id获得用户信息
  '''
  user_sql = '''
    SELECT user_id, name FROM user WHERE user_id IN({user_id});
  '''.format(user_id = ','.join(user_ids))
  user_info = pd.read_sql(user_sql, conn)
  return user_info

def get_order_info(user_ids, conn=None):
  '''
  通过 用户ID 获得订单信息
  '''
  order_sql = '''
    SELECT user_id, order_id, num FROM orders WHERE user_id IN({user_id});
  '''.format(user_id = ','.join(user_ids))
  order_info = pd.read_sql(order_sql, conn)
  return order_info
  
def get_order_good_info(order_ids, conn=None):
  '''
  通过上面获得的 订单ID 获得订单商品信息。
  '''
  order_good_sql = '''
    SELECT order_id, good_name FROM order_good WHERE order_id IN ({ids});
  '''.format(ids = ','.join(order_ids))
  order_good_info = pd.read_sql(order_good_sql, conn)
  return order_good_info

def get_coupon_info(order_ids, conn=None):
  '''
  通过 订单ID 获得券信息
  '''
  coupon_sql = '''
    SELECT order_id, name FROM coupon WHERE order_id IN({ids});
  '''.format(ids = ','.join(order_ids))
  coupon_info = pd.read_sql(coupon_sql, conn)
  return coupon_info

def get_order_detail(user_id, conn=None):
  '''
  拼凑订单信息
  '''
  user_ids = [str(user_id)]
  # 获得用户信息
  user_info       = get_user_info(user_ids, conn=conn)
  # 获得订单信息
  order_info      = get_order_info(user_ids, conn=conn)
  # 获得订单ID
  order_ids       = order_info['order_id'].astype(str)
  # 获得订单商品信息
  order_good_info = get_order_good_info(order_ids, conn=conn)
  # 获得券
  coupon_info     = get_coupon_info(order_ids, conn=conn)
  # 用户信息 + 订单信息
  new_data_1 = user_info.merge(order_info, 
                               left_on='user_id', 
                               right_on='user_id', 
                               how='left')
  # new_data_1 + 订单商品信息
  new_data_2 = new_data_1.merge(order_good_info,
                                left_on='order_id',
                                right_on='order_id',
                                how='left')
  # new_data_2 + 券信息
  new_data_3 = new_data_2.merge(coupon_info, 
                                left_on='order_id', 
                                right_on='order_id', 
                                how='left')
  return new_data_3


if __name__ == '__main__':
  conf = {
    'host'     : '127.0.0.1',
    'port'     : '3306',
    'database' : 'test',
    'user'     : 'root',
    'password' : 'root'
  }
  conn = mysql.connector.connect(**conf)

  print get_order_detail(10, conn=conn)

  conn.close()
